{
  Autor            : Michael Springwald
  Erstellung Datum : Unbekannt
  Updatets         : 04.04.2007, Donnerstag, 26.Juli.2007
                     Donnerstag, 16.Augst.2007, Mittwoch, 05.September.2007,
                     Mittwoch, 28.November.2007, Sontag, 09.Dezember.2007
                     Mittwoch, 12.Dezemeber.2007, Donnerstag, 13.Dezember.2007
                     Donnerstag, 20.Dezember.2007, Samstag, 22.Dezember.2007
                     
}

unit Tools;

interface
  uses Sysutils,inifiles,  Classes,dialogs,lcltype;

const
  Stop      = 0;
  Abbrechen = 1;
  Weiter    = 2;

type
  TStr = record
    vor, dahinter:String;
  end;


  // Fügt eine Stringlist in eine andere ein
  procedure StringListAddTo(aStr1,aStr2:TStrings);
  procedure LoadGermanNames;
// -- String verarbeitung --
  function StringToCharIndex(const aValue:String):String;
  // Unterstützt solche strings( "Hallo du da" wie geht "608246 0")
  function GetTokenExt(str:String; septChar1,septChar2:Char; TokenNr:Integer):String;
  // SetToken
  
   // ndert einen tocken in einem String und gibt dann den neuen string zurck
  function SetTokenExt(OldString, NewText:String; SeptChar,SeptChar2:Char; TokenNr:Integer):String;

  function GetBool(Str:String):Boolean;
  // Lscht den letzten eintrag vom verzeichnis
  function DelStr(s:String):String;
  // Teilt den String in zwei hlften und gibt die angebe hlfte zurck
  function SplitStr(str:String;ch:Char):string;
  // gibt die Richtungs tasten(Lings, Rechts, Oben, Unten) als namen zurck
  function GetKeyName(Key:Word):String;

  // Zhlt die vorkommen von einem Bestimmten zeichen*
  function NumToken(aString: String; SepChar: Char):Byte;

  // gibt einen vorkommen als string zurck *
  function GetToken(aString: String; SepChar: Char; TokenNum: Byte):String;

  // Lscht einen tocken in einem String und gibt dann den neuen string zurck
  function DelToken(aString,delstr: String):String;

   // ndert einen tocken in einem String und gibt dann den neuen string zurck
  function SetToken(OldString, NewText:String; SeptChar:Char; TokenNr:Integer):String;


  // Zhlt ein bestimmtes zeichen in einem String
  function GetCharCount(C:PChar; str:String):Integer;
  function RandomRange(min, max: integer): integer; 

// -- Sonstige funktionen --

  // Schreibt in ein RichEdit in der angeben pos(Funktiniert auch bei memo: muss man nur anpassen)*
  procedure str_into_RichEdit(Liste1215:TStringList;Insert_Text:string; line:integer; position:integer);

  // gib eine zufalls zahl zwischen den angeben wert und den angeben wert zu rck
  function Random2(von, bis:Integer):Integer; overload;

  // gibt eine zahl zwischen von und bis auser der in zu angeben zahl
  function Random2(von, bis, zu:Integer):Integer; overload;

  // sucht sich aus den angeben zahlen eine
  function RandomZahl(Zahlen:array of Integer ):Integer;

  // Sucht in einem interger Array einen wert und gibt True wenn er in gefunden hat zurck
  function GetArrayValue(z:array of Integer; wert:Integer):Boolean;

  // nimmer vor - die erste Zahl und nachdem - die zweite
  function Random2A(wert:String):Integer;

  // Gibt eine zufallige Zahl zurck aus der angeben
  function Random2B(Bis, Aus:Integer):Integer;

  // Sucht sich aus einer Booleannischen liste einen Index aus die True ist
  function Random2C(Liste:array of Boolean):Integer;

  // String verschlsseln*
  function myCoder(s: string; password: Integer; decode: Boolean):string;

  // Stream Funktionen

  // Kopiert einen Stream in den andren wobei man in abbrechen kann
  procedure CopyFrom(Qulle, Ziel:TStream; Size:Integer);
  
  // wandelt MS in Minuten und Sektunden um*
  function GetMSToMinSek(ms:Integer; mo:boolean; ms2:Integer):String;

  // Macht aus einer TStringList.Text eigenschaft ein String
  function TStringsToStr(strings:TStrings):String;
  // macht aus einem text einen TSTringList.text
  function StrToTSTrings(text:String):TStrings;
  
  // Stellt eine erweiterte Pos Funktion zu verfügung
  function PosExt(const SubStr, source:WideString; const aPosX:Integer):Integer;

  function NextWord(var FirstIndex, LastIndex: Integer; var at:widestring; Soruce, SubStr:widestring):string;
  function NextHtml(var FirstIndex, LastIndex: Integer;
  var aCommand:widestring; const asoruce: widestring):String;
implementation

uses Tools_File;

function TStringsToStr(strings:TStrings):String;
var
  i:Integer;
  str:String;                          
begin
  for i:=0 to strings.Count-1 do begin
    with strings do begin
      if i = 0 then 
        str:=strings[i]
      else
        str:=str + '|' + strings[i];
    end;
  end;
  result:=str;
end;

function GetBool(Str:String):Boolean;
begin
  if UpperCase(Str) = 'TRUE' then
    result:=True
  else
    result:=False;
end;

function DelStr(s:String):String;
var
  x:Integer;
begin
  for x:=Length(s)-2 downto 0 do begin
    if s[x] = '\' then begin
//      Delete(s,x,StrLen(PChar(s)));
      break;
    end;
  end;
  result:=s +'\';
end;

function Random2A(wert:String):Integer;
begin
 // Randomize;
  if Pos('-',wert) > 0 then
    result:=Random2(StrToInt(GetToken(wert,'-',1)),StrToInt(GetToken(wert,'-',2)))
  else
    result:=StrToInt(wert);
end;

function SplitStr(str:String;ch:char):string;
var
  i:Integer;
begin
  for i:=(Length(str)-1) downto 1 do begin
    if str[i] = ch then begin
      Delete(str,i,Length(str));
      Break;
    end;
  end;
  result:=str;
end;

function GetMSToMinSek(ms:Integer; mo:boolean = True;ms2:Integer = 0):String;
var
  m,s:Integer;
begin
  if mo = True then begin
    ms:=ms  div 1000;
    s:=ms;
    m:=s div 60;

    if s >= 60 then
      s:=s-60*(s div 60)+1;

    result:=Format('%.2d:%.2d ',[m,s]);
  end
  else begin
    ms:=(ms2-ms) div 1000;
    s:=ms;
    m:=s div 60;

    if s >= 60 then
      s:=s-60*(s div 60)+1;

    result:=Format('%.2d:%.2d ',[m,s]);
  end;

end;


function GetCharCount(C:PChar; str:String):Integer;
var
  i,z:Integer;
begin
  z:=0;
  for i:=1 to (Length(str)-1) do begin
    if str[i] = C then
      inc(z);
  end;
  result:=z
end;

function GetArrayValue(Z:array of Integer; wert:Integer):Boolean;
var
  i:integer;
  t:Boolean;
begin
  t:=False;
  for i:=0 to HIGH(z) do begin
    if z[i] = wert then begin
      t:=True;
      break;
    end;
  end;
  result:=t;
end;

procedure CopyFrom(Qulle, Ziel:TStream; Size:Integer);
var
  s, t:Integer;
  doStop:Boolean;
begin
  t:=-1;
  if Size = 0 then begin
    Qulle.Position:=0;
    Size:=Qulle.Size;
  end;

  s:=Ziel.position+Size;
  while not doStop do begin
    if Ziel.position+1 <= s then begin
      t:=Ziel.CopyFrom(Qulle,1);
//      Application.ProcessMessages; //damit man auf den Abbrechen Button drcken kann
    end
    else
      doStop:= true;
  end;
  doStop:=False;
end;


function myCoder(s: string; password: Integer; decode: Boolean):string;
var 
  i, c, x: Integer; 
begin 
  if decode then x := -1 else x := 1; 
  RandSeed := password; 
  Result := ''; 
  for i := 1 to length(s) do 
  begin 
    c := ord(s[i]); 
    if c in [32..122] then 
    begin 
      c := c+(x*Random(90)); 
      if (c<32) or (c>122) then c := c-(x*90); 
    end; 
    Result := Result + chr(c); 
  end; 
end; 

function Random2C(Liste:array of Boolean):Integer;
var
  r:Integer;
begin
  r:=Random(High(Liste));
  repeat
    r:=Random(High(Liste));
  until Liste[r] = True;
  result:=r;
end;

function Random2B(Bis, Aus:Integer):Integer;
var
  r:Integer;
begin
  r:=random(bis);
  repeat
    r:=random(bis);
  until r <> aus;
  result:=r;

end;

function RandomZahl(Zahlen:array of Integer):Integer;
var
  r,m:Integer;
begin
  r:=-1;
  M:=High(Zahlen)+1;
  r:=random(m);
  result:=Zahlen[r];
end;

function Random2(von, bis,zu:Integer):Integer;
var
  z:Integer;
begin
  z:=-1;
  repeat
    z:=random(bis+1);
  until (z >= von) and (z <= bis) and (zu <> z);
  result:=z;  
end;

function RandomRange(min, max: integer): integer;
begin
  result := 0;
  if min > max then
    exit;
  result := random(max - min + 1) + min;  
end;

function Random2(von, bis:Integer):Integer;
begin
{  z:=0;
  Randomize;
  repeat
    z:=random(bis)+1;
  until (z >=von) and (z<=bis);
  result:=z;  }
  result:=RandomRange(von,bis);
end;



function GetKeyName(Key:Word):String;
begin
  if Key = VK_LEFT then result:='Pfeil Taste Links';
  if Key = VK_RIGHT then result:='Pfeil Taste Rechts';
  if Key = VK_UP then result:='Pfeil Taste Oben';
  if Key = VK_Down then result:='Pfeil Taste Unten';  
end;

procedure str_into_RichEdit(Liste1215:TStringList;Insert_Text:string; line:integer; position:integer);
var
  h : integer;
begin

with Liste1215 do begin 
  for h := Count to line-1 do 
    Add(''); 

  for h := length(Strings[line-1]) to position do
    Strings[line-1] := Strings[line-1] + ' '; 

  Strings[line-1] := copy(Strings[line-1], 1, position-1) + Insert_Text + copy(Strings[line-1], position+1, length(Strings[line-1])); 

end;end;

function DelToken(aString,delstr: String):String;
begin
  result:=StringReplace(aString,delstr,'',[]);
end;

procedure StringListAddTo(aStr1, aStr2: TStrings);
var
  I:Integer;
begin
  for i:=0 to aStr1.Count-1 do begin
    aStr2.Add(aStr1[i]);
  end;
end; //StringListAddTo

procedure LoadGermanNames;
begin
  DefaultFormatSettings.LongDayNames[1]:='Sontag';
  DefaultFormatSettings.LongDayNames[2]:='Montag';
  DefaultFormatSettings.LongDayNames[3]:='Dienstag';
  DefaultFormatSettings.LongDayNames[4]:='Mittwoch';
  DefaultFormatSettings.LongDayNames[5]:='Donnertag';
  DefaultFormatSettings.LongDayNames[6]:='Freitag';
  DefaultFormatSettings.LongDayNames[7]:='Samstag';

  DefaultFormatSettings.ShortDayNames[1]:='So';
  DefaultFormatSettings.ShortDayNames[2]:='Mo';
  DefaultFormatSettings.ShortDayNames[3]:='Di';
  DefaultFormatSettings.ShortDayNames[4]:='Mi';
  DefaultFormatSettings.ShortDayNames[5]:='Do';
  DefaultFormatSettings.ShortDayNames[6]:='Fr';
  DefaultFormatSettings.ShortDayNames[7]:='Sa';

  DefaultFormatSettings.LongMonthNames[1]:='Januer';
  DefaultFormatSettings.LongMonthNames[2]:='Febuar';
  DefaultFormatSettings.LongMonthNames[3]:='März';
  DefaultFormatSettings.LongMonthNames[4]:='April';
  DefaultFormatSettings.LongMonthNames[5]:='Mai';
  DefaultFormatSettings.LongMonthNames[6]:='Juni';
  DefaultFormatSettings.LongMonthNames[7]:='Juli';
  DefaultFormatSettings.LongMonthNames[8]:='Augst';
  DefaultFormatSettings.LongMonthNames[9]:='September';
  DefaultFormatSettings.LongMonthNames[10]:='Oktober';
  DefaultFormatSettings.LongMonthNames[11]:='Nowember';
  DefaultFormatSettings.LongMonthNames[12]:='Dezember';

  DefaultFormatSettings.ShortMonthNames[1]:='Jan';
  DefaultFormatSettings.ShortMonthNames[2]:='Feb';
  DefaultFormatSettings.ShortMonthNames[3]:='Mär';
  DefaultFormatSettings.ShortMonthNames[4]:='Apr';
  DefaultFormatSettings.ShortMonthNames[5]:='Mai';
  DefaultFormatSettings.ShortMonthNames[6]:='Jun';
  DefaultFormatSettings.ShortMonthNames[7]:='Jul';
  DefaultFormatSettings.ShortMonthNames[8]:='Aug';
  DefaultFormatSettings.ShortMonthNames[9]:='Okt';
  DefaultFormatSettings.ShortMonthNames[10]:='Sep';
  DefaultFormatSettings.ShortMonthNames[11]:='Now';
  DefaultFormatSettings.ShortMonthNames[12]:='Dez';
end;

function StringToCharIndex(const aValue: String): String;
var
  x:Integer;
  str:String;
  k:Integer;
begin
  str:='';
  k:=0;
  for x:=1 to Length(aValue) do begin
    k:=k+ord(AValue[x]);
  end;
  str:=IntTostr(k);
  result:=str;
end;

function GetTokenExt(str:String; septChar1,septChar2:Char; TokenNr:Integer):String;
var
  x,x1,x2,index,t,l:Integer;
  str1:String;
begin
  l:=Length(str);
  index:=0;  t:=0; x1:=0; x2:=0;
  for x:=1 to l do begin
    if (str[x] = SeptChar2) and (index <> 2) then begin
      index:=2;
    end
    else begin
      if (index = 2) and (str[x] = SeptChar2) then begin
        index:=0;
      end;
    end;

    if (x =l ) or (str[x] = SeptChar1) and (index = 0) then begin
      inc(t);
      if t = tokennr then begin
        if x = l then
          str1:=copy(str,x1+1,(x-x1)+1)
        else
          str1:=copy(str,x1+1,x-x1);

        break;
      end;
      x1:=x;
    end;
  end;
  result:=str1;
end;

function NumToken(aString: String; SepChar: Char):Byte;
var
   RChar     : Char;
   StrLen    : Byte;
   TNum      : Byte;
   TEnd      : Byte;

begin
  if SepChar = '#' then begin
    RChar := '*'
  end
  else begin
    RChar := '#'
  end;
   StrLen := Length(aString);
   TNum   := 0;
   TEnd   := StrLen;
  while TEnd <> 0 do  begin
    Inc(TNum);
    TEnd := Pos(SepChar,aString);
    if TEnd <> 0 then begin
      aString[TEnd] := RChar;
    end;
  end;
  Result := TNum;
end;

function GetToken(aString: String; SepChar: Char; TokenNum: Byte):String;
var
   Token     : String;
   StrLen    : Byte;
   TNum      : Byte;
   TEnd      : Byte;

begin
  if aString <> '' then begin
    StrLen := Length(aString);
    TNum   := 1;
    TEnd   := StrLen;
    while ((TNum <= TokenNum) and (TEnd <> 0)) do begin
    //"Test wie geht es dir so" hallo "Tach"
      TEnd := Pos(SepChar,aString);
      if TEnd <> 0 then begin
        Token := Copy(aString,1,TEnd-1);
        Delete(aString,1,TEnd);
        Inc(TNum);
      end else Token := aString;
    end;

    if TNum >= TokenNum then
      Result := Token
    else begin
      Result := Format('Fehler: Tokennummer (%s) ist grer als token !',[aString]);
//      MessageBox(0,pchar(Result),nil,MB_OK or MB_ICONEXCLAMATION);
    end;
  end;
end;

function SetTokenExt(OldString, NewText:String; SeptChar,SeptChar2:Char; TokenNr:Integer):String;
var
  ende,x,SeptCount:Integer;
  str:String;
begin
  if TokenNr > NumToken(OldString,SeptChar) then begin
    result:='1';
    exit;
  end;

  SeptCount:=0; str:='';

  for x:=1 to Length(OldString) do begin
    if OldString[x] = SeptChar then inc(SeptCount);
    if SeptCount = TokenNr-1 then begin
      str:=OldString;
      ende:=Length( GetTokenExt(OldString,SeptChar,SeptChar2,TokenNr));
      Delete(str, x+1, ende);
      insert(NewText,str,x+1);
      result:=str;
      Break;
    end;
  end;
end;


function SetToken(OldString, NewText:String; SeptChar:Char; TokenNr:Integer):String;
var
  ende,x,SeptCount:Integer;
  str:String;
begin
  if TokenNr > NumToken(OldString,SeptChar) then begin
    result:='1';
    exit;
  end;

  SeptCount:=0; str:='';

  for x:=1 to Length(OldString) do begin
    if OldString[x] = SeptChar then inc(SeptCount);
    if SeptCount = TokenNr-1 then begin
      str:=OldString;
      ende:=Length( GetToken(OldString,SeptChar,TokenNr));
      Delete(str, x+1, ende);
      insert(NewText,str,x+1);
      result:=str;
      Break;
    end;
  end;
end;

function StrToTSTrings(text:String):TStrings;
var
  i:Integer;
  l:TStringList;
begin
  l:=TSTringList.Create;
  for i:=1 to NumToken(text,'|') do begin
    l.Add(GetToken(text,'|',i))
  end;
  result:=l;
end;

function PosExt(const SubStr, source: WideString; const aPosX: Integer): Integer;
var
  i,MaxLen : SizeInt;
  pc : pwidechar;
begin
  PosEXT:=0;
  if Length(SubStr)>0 then begin
     MaxLen:=Length(source)-Length(SubStr);
     i:=aPosX;
     pc:=@source[i];
     while (i<=Length(source)) do
      begin
        inc(i);
        if (SubStr[1]=pc^) and
           (CompareWord(Substr[1],pc^,Length(SubStr))=0) then
         begin
           PosEXT:=i;
           exit;
         end;
        inc(pc);
      end;
   end;
end; // PosExt

function NextWord(var FirstIndex, LastIndex: Integer; var at:widestring; Soruce, SubStr:widestring): string;
begin
  LastIndex:=PosExt(SubStr,Soruce,FirstIndex)-1;
  result:=copy(Soruce,FirstIndex,abs(LastIndex-FirstIndex));
  at:=copy(Soruce,LastIndex,Length(SubStr)+1);
  FirstIndex:=PosExt(SubStr,Soruce,LastIndex)+1;
end; // NextWord

function NextHtml(var FirstIndex, LastIndex: Integer;
  var aCommand:widestring; const asoruce: widestring): String;
begin
  lastindex:=PosExt('<',asoruce,FirstIndex);

//  writeln(Firstindex,'\',Length(asoruce));

  if LastIndex > 0 then begin
    result:=Copy(asoruce,FirstIndex,abs(LastIndex-FirstIndex)-1);
    FirstIndex:=PosExt('>',asoruce,LastIndex);
    aCommand:=Copy(asoruce,LastIndex,abs(LastIndex-(FirstIndex-1)));
  end
  else begin
    aCommand:='';
    result:=Copy(asoruce,FirstIndex,Length(asoruce));
  end;


end;  // NextHtml

end.
